part of selene;

/// A two-way channel between this user, and another Discord user.
class DMChannel extends Channel with TextChannel {
  /// Creates a new [DMChannel].
  DMChannel(Client client) : super(client);

  /// The other member of this DM.
  User partner;

  @override
  void _update(Map<String, dynamic> model) {
    super._update(model);

    if ((model['recipients'] ?? []).length == 1) {
      if (client.cache.users[model['recipients'][0]['id']] != null) {
        partner = client.cache.users[parseInt(
            (model['recipients'].first['id']) ?? '')];
      } else {
        partner = new User(client);
        partner._update(model['recipients'].first);
        client.cache.users[partner.id] = partner;
      }
    }
    lastMessageId = parseInt(model['last_message_id']) ?? lastMessageId;
  }

  @override
  String toString() =>
      "DM between ${client.cache.self.username} and ${partner.username}";
}
