part of selene;

/// A guild channel with messaging capability.
class GuildTextChannel extends GuildChannel with TextChannel {
  /// Creates a new [GuildTextChannel].
  GuildTextChannel(Guild guild, Client client) : super(guild, client);

  /// The current topic of this channel.
  String topic;

  /// The date and time the last pinned message was pinned.
  DateTime lastPin;

  @override
  void _update(Map<String, dynamic> model) {
    super._update(model);

    topic = emptyReplace(model['topic'], topic);

    lastMessageId =
        int.tryParse(model['last_message_id'] ?? '') ?? lastMessageId;
    if (model['last_pin_timestamp'] != null) {
      lastPin = DateTime.parse(model['last_pin_timestamp']);
    }
  }
}
