part of selene;

/// A reaction to a message on Discord.
class Reaction extends Entity {
  /// Creates a new [Reaction].
  Reaction(Client client) : super(client);

  /// The amount of times this Emote has been used to react.
  int count;

  /// Whether the current user has reacted.
  bool haveReacted;

  /// Whether the current user has not reacted.
  bool get hasNotReacted => !haveReacted;

  /// The Emote that was used to react.
  Emote emote;

  @override
  void _update(Map<String, dynamic> model) {
    super._update(model);

    count = model['count'];
    haveReacted = model['me'];

    if (model['emoji']['id'] == null) {
      emote = new StandardEmote(client);
      emote._update(model['emoji']);
    } else {
      emote = client.cache.guildEmotes[model['emoji']['id']];
    }
  }
}
