part of selene;

/// A utility to construct embeds.
class EmbedBuilder {
  /// The title of this embed.
  String title;

  /// The type of this embed. Usually 'rich'.
  String type = 'rich';

  /// The description of this embed.
  String description;

  /// The URL of this embed.
  String url;

  /// The author of this embed.
  EmbedAuthorBuilder author;

  Map<String, dynamic> build() {
    var map = <String, dynamic>{};

    map['title'] = title;

    removeNullRecords(map);

    return map;
  }
}

/// A utility to construct embed author objects.
class EmbedAuthorBuilder {
  /// The name of this author.
  String name;

  /// The icon URL of this author.
  String iconUrl;

  /// The URL to this author's webpage.
  String url;

  /// Whether this author object is empty.
  bool get isEmpty => name.isEmpty;

  /// Whether this author objet is not empty.
  bool get isNotEmpty => name.isNotEmpty;

  /// Constructs an embed author builder using properties of a [User].
  EmbedAuthorBuilder.fromUser(User user) {
    name = user.username;
  }

  /// Constructs a blank embed author builder.
  EmbedAuthorBuilder();
}
